{
OpenRPG - A engine for making RPG audiogames
Based on the Last Crusade audiogame of Patrick Dwyer & Peter S. VanLund
Idealized in Delphi/Pascal by Lucas Alexandre - Sociedade dos Nego
}

program OpenRPG;
{$APPTYPE CONSOLE}
uses console, GameUI, rfile, rgame, rvars, SDL, SDL_Mixer, sound, sysUtils;

procedure LoadGame;
var i: integer;
begin
MusicFadeOut(3000);
for i:=1 to 6 do sleep(499);
play('sounds\loading.wav',0);
if not ReadSession(player.map,'MAP') then exit;
map.name:=ReadValue('name');
play('sounds\entering.wav',0);
play(map.name,0);
player.hp:=100;
end;

function processBlock: boolean;
var s, t: string;
b: boolean;
c: char;
r: integer;

a: integer;
d: integer;
ahp: integer;
enemy: string;
pa: integer;
pd: integer;
v: string;
w: string;
label action;
procedure LoadMusic;
begin
if not ReadSession(player.map,player.block) then exit;
block.bg:=readValue('bg');
OpenMusic(block.bg);
PlayMusic(-1);
end;
function CheckVictory: boolean;
begin
CheckVictory:=false;
if (ahp<=0) then
begin
b:=false;
play('sounds\victory.wav',0);
MusicFadeOut(1000);
sleep(1000);
player.defeat.Add(enemy);
CheckVictory:=true;
end;
end;
function CheckDeath: boolean;
begin
CheckDeath:=false;
if (player.hp<=0) then
begin
play('sounds\player_x.wav',0);
processBlock:=false;
CheckDeath:=true;
exit;
end;
end;
procedure attack1;
begin
play(v,0);
r:=random(pa)+3;
r:=r-d;
if r=0 then
play('sounds\player_m.wav',0)
else
begin
ahp:=ahp-r;
play('sounds\player_a.wav',0);
speakNumber(r);
if CheckVictory then
begin
LoadMusic;
exit;
end;
play('sounds\enemy_nh.wav',0);
speakNumber(ahp);
play('sounds\hp_remain.wav',0);
end;
end;
procedure attack2;
begin
randomize;
play(w,0);
r:=random(strToInt(readValue('attack')))+3;
r:=r-pd;
if r<=0 then
play('sounds\enemy_m.wav',0)
else
begin
player.hp:=player.hp-r;
play('sounds\player_l.wav',0);
speakNumber(r);
if r>1 then
play('sounds\hp.wav',0)
else play('sounds\hp.wav',0);
CheckDeath;
play('sounds\player_nh.wav',0);
speakNumber(player.hp);
if player.hp>1 then
play('sounds\hp_remain.wav',0)
else play('sounds\hp_remain1.wav',0);
end;
end;
begin
processBlock:=true;
if not ReadSession(player.map,player.block) then exit;
s:=readValue('person');
if s<>'' then
begin
readSession('characters.rpg',s);
t:=readValue('type');
if t='eneme' then
begin
if defeated(s) then
begin
LoadMusic;
goto action;
end;
enemy:=s;
OpenMusic('sounds\fight.ogg');
playMusic(-1);
play('sounds\encountered.wav',0);
play(readValue('name'),0);
play('sounds\enemy_a.wav',0);
speakNumber(strToInt(readValue('attack')));
play('sounds\enemy_d.wav',0);
speakNumber(strToInt(readValue('defense')));
play('sounds\enemy_h.wav',0);
t:=readValue('hp');
speakNumber(strToInt(t));
ahp:=strToInt(t);
b:=true;
a:=strToInt(readValue('attack'));
d:=strToInt(readValue('defense'));
w:=readValue('sound');
ReadSession('weapons.rpg',player.attack);
v:=readValue('sound');
pa:=strToInt(readValue('attack'));
ReadSession('weapons.rpg','defense');
pd:=strToInt(readValue('defense'));
if strToInt(t)>1 then
play('sounds\hp.wav',0)
else play('sounds\hp1.wav',0);
play('sounds\run_away.wav',0);
repeat
c:=upcase(readkey);
until (c='Y') or (C='N') or (C='A');
if c='Y' then
begin
randomize;
r:=random(3);
if r=1 then
begin
play('sounds\run_yes.wav',0);
MusicFadeOut(1000);
sleep(1000);
player.block:=LastBlock;
exit;
end
else
play('sounds\run_no.wav',0);
end;
attack2;
end;
if t='friend' then
begin
LoadMusic;
if talked(s) then
begin
play('sounds\talkto.wav',0);
play(readValue('name'),0);
c:=upcase(readkey);
if c<>'Y' then goto action;
end;
player.talk.Add(s);
play(readValue('dialog'),0);
end;
end;

action:
c:=upcase(readkey);
if c=#32 then
begin
readSession('weapons.rpg',player.attack);
play('sounds\player_s.wav',0);
SpeakNumber(strToInt(readValue('attack')));
ReadSession('weapons.rpg',player.defense);
play('sounds\player_d.wav',0);
SpeakNumber(strToInt(readValue('defense')));
play('sounds\player_nh.wav',0);
speakNumber(player.hp);
if player.hp>1 then
play('sounds\hp.wav',0)
else play('sounds\hp1.wav',0);
end;
if c in [#72..#80] then
begin
if c=#72 then c:='n';
if c=#75 then c:='o';
if c=#77 then c:='l';
if c=#80 then c:='s';
ReadSession(player.map,player.block);
s:=ReadValue(c);
if s<>'' then
begin
play('sounds\g_heading.wav',0);
LastBlock:=player.block;
case c of
'n': play('sounds\g_north.wav',0);
's': play('sounds\g_south.wav',0);
'l': play('sounds\g_east.wav',0);
'o': play('sounds\g_west.wav',0);
end;
MusicFadeOut(1000);
sleep(1000);
player.block:=s;
exit;
end;
end;
if c='R' then exit;
if (c='A') and (b) then
begin
attack1; if b then attack2;
if not b then exit;
end;
c:=#0;
goto action;

end;

function menu: boolean;
var c: char;
begin
menu:=true;
if (c=#0) or (c='1') or (c='2') or (c='3') then
play('sounds\menu.wav',0);
c:=upcase(readkey);
case c of
#27: halt;
'1':
begin
LoadGame;
while processBlock do;
end;
'3': begin
play('sounds\dir_skip.wav',0);
play('sounds\dir_spacebar.wav',0);
play('sounds\dir_characters.wav,0',0);
play('sounds\dir_enemy.wav',0);
play('sounds\dir_items.wav',0);
play('sounds\dir_location.wav',0);
play('sounds\dir_save.wav',0);
play('sounds\dir_quit.wav',0);
end;
end;
c:=#0;
end;

begin
if not OpenCFG then halt;
GameInfo;
with game do
begin
if title='' then title:='OpenRPG';
if load='' then exit;
SetWindowTitle(title);
OpenMusic('sounds\main_theme.ogg');
PlayMusic(-1);
play('sounds\title.wav',0);
play('sounds\menu.wav',0);
end;
while menu do;
readln;
end.
