unit rgame;
interface
uses classes;
type
tGame = record
title: string;
load: string;
end;
tPlayer = record
attack: string;
block: string;
defense: string;
gold: word;
hp: byte;
map: string;
talk: TStringList;
defeat: TStringList;
end;
tMap = record
name: string;
bg: string;
end;
tBlock = record
bg: string;
end;
var
block: tBlock;
game: tGame;
LastBlock: string;
map: tMap;
player: tPlayer;
procedure GameInfo;
procedure SpeakNumber(n: integer);
function talked(name: string): boolean;
function defeated(name: string): boolean;
implementation
uses rfile, sound,  sysUtils;

procedure GameInfo;
begin
if not ReadSession('OpenRPG.cfg','OpenRPG') then exit;
game.title:=ReadValue('title');
game.load:=ReadValue('load');
player.gold:=strToInt(readValue('gold'));
player.attack:=readValue('attack');
player.defense:=readValue('defense');
player.map:=game.load;
player.block:=readValue('block');
end;

procedure SpeakNumber(n: integer);
var s: string;
i: integer;
begin
s:=intToStr(n);
if n<=20 then
play('numbers\'+s+'.wav',0);
if (n>20) and (n<99) then
begin
play('numbers\'+s[1]+'0.wav',0);
if s[2]<>'0' then play('numbers\'+s[2]+'.wav',0);
end;
if (n>99) and (n<1000) then
begin
play('numbers\'+s[1]+'.wav',0);
play('numbers\hundred.wav',0);
if (s[2]='0') and (s[3]='0') then exit;
play('numbers\'+s[2]+'0.wav',0);
if s[3]<>'0' then play('numbers\'+s[3]+'.wav',0);
end;
if n>1000 then
for i:=1 to length(s) do
play('numbers\'+s[i]+'.wav',0);
end;

function defeated(name: string): boolean;
var i: integer;
begin
defeated:=false;
for i:=0 to player.defeat.count-1 do
if player.defeat[i]=name then
defeated:=true;
end;

function talked(name: string): boolean;
var i: integer;
begin
talked:=false;
for i:=0 to player.talk.count-1  do
if player.talk[i]=name then
talked:=true;
end;

begin
player.talk:=TStringList.Create;
player.defeat:=TStringList.Create;
end.
